#include "testlib.h"
#include <iostream>
#include <algorithm>

using namespace std;

string get10(int len) {
    string p;
    p.push_back('1');
    for (int i = 0; i < len; i++) {
        p.push_back('0');
    }
    return p;
}

const int maxLen[] = {3, 6, 18, 1000000};
string maxR[] = {get10(maxLen[0]), get10(maxLen[1]), get10(maxLen[2]), get10(maxLen[3])};

bool isLessOrEqual(string s1, string s2) {
    if (s1.size() < s2.size()) {
        return true;
    }
    if (s1.size() > s2.size()) {
        return false;
    }
    return s1 <= s2;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    ensure(group >= 0 && group <= 4);

    string num[2];
    int curId = 0;
    int curSym;
    int was = 0;
    while ((curSym = inf.readChar()) != EOFC && (curSym) != EOF) {
        ensure(curId < 2);
        if (!(curSym >= '0' && curSym <= '9')) {
            inf.unreadChar(curSym);
            inf.readEoln();
            curId++;
            continue;
        }
        ensure(curSym >= '0' && curSym <= '9');
        num[curId].push_back(curSym);
    }
    inf.readEof();
    ensure(curId == 2);
    ensure(num[0].size() >= 1 && num[1].size() >= 1);
    ensure(num[0][0] != '0' && num[1][0] != '0');
    ensure(isLessOrEqual(num[0], num[1]));
    if (group == 0) {
        group = 1;
    }
    group--;
    ensure(isLessOrEqual(num[1], maxR[group]) && !isLessOrEqual(num[0], "0"));
}
